VERSION 8000; ; 8407
* Allg_BspDialogLayout.CSX  verschiedene Dialoglayouts  19.11.11
* -----------------------------------------------------------------------------
* @filedoc
* @file Allg_BspDialogLayout.CSX
* @brief Beispiele fr verschiedene Dialoglayouts 
* 
* Dieses Skript enthlt Beispiele fr verschiedene Dialoglayouts.
* Die Funktionen mit den Dialogbeispielen werden aus einem CAD-Men gestartet.
* 
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author HB
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------
* 
BILDSCHIRM GRAFIK
* Deklarationen
SYMBOLE /CAD_MENU/ Menu
SYMBOLE /CAD_REQUEST/ Request
SYMBOLE * Ret; NewId; FuncId; Test 
* CAD - Men
Menu = System.CreateCadMenu()
Menu.SetHeadline("Layoutbeispiele")
Menu.AddBlankItem()
Menu.AddFunctionItem(1; "Einfach"; "Standardlayout")
Menu.AddBlankItem()
Menu.AddCaption("Rahmen unsichtbar")
Menu.AddFunctionItem(2; "Nebeneinander"; "Layout mit zwei unsichtbaren Rahmen nebeneinander")
Menu.AddFunctionItem(3; "Untereinander"; "Layout mit zwei unsichtbaren Rahmen untereinander")
Menu.AddBlankItem()
Menu.AddCaption("Rahmen sichtbar")
Menu.AddFunctionItem(4; "Nebeneinander"; "Layout mit zwei sichtbaren Rahmen nebeneinander")
Menu.AddFunctionItem(5; "Untereinander"; "Layout mit zwei sichtbaren Rahmen untereinander")
Menu.AddFunctionItem(6; "Neben/Untereinander"; "Layout mit drei sichtbaren Rahmen neben-/untereinander")

* CAD - Men ausfhren
NewId = 0
FuncId = 0
SOLANGE Test = Menu.CheckId(FuncId)
  NewId = 0
  VERZWEIGE FuncId
  ZWEIG 0 |.....................................keine Funktion aktiv
    Request = Menu.CreateRequest()
    Request.SetPrompt("Dialoglayout whlen")
    NewId = Request.DoDialog()  
    
  ZWEIG 1 |..............................einfach
    LayoutEinfach
    
  ZWEIG 2 |..............................zweispaltig
    LayoutZweiRahmen 1                  |Pos=1; Rahmen=0 
    
  ZWEIG 3 |..............................zweireihig
    LayoutZweiRahmen 0                  |Pos=0; Rahmen=0
    
  ZWEIG 4 |..............................Rahmen 1
    LayoutZweiRahmen 1; 1               |Pos=1; Rahmen=1
    
  ZWEIG 5 |..............................Rahmen 2
    LayoutZweiRahmen 0; 1               |Pos=0; Rahmen=1 
    
  ZWEIG 6 |..............................drei Rahmen
    LayoutDreiRahmen 
    
  ENDE VERZWEIGE 
  FuncId = NewId
ENDE SOLANGE

STOP
* ----------------------------------------------------------------------------- 
FUNKTION LayoutEinfach:

* Deklarationen
  SYMBOLE /DLG_WINDOW/ Dialog
  SYMBOLE /DLG_TEXT/ TextFeld
  SYMBOLE /DLG_COMBOBOX/ Combo
  SYMBOLE /DLG_CHECKBOX/ Check
  SYMBOLE /DLG_NUMBER/ Number
  SYMBOLE * !Text; Wert; Bool; Kenn; Ret
*...................Inhalte vorbelegen
  !Text = "Hallo!"
  Wert = 123.456
  Bool = 1
  Kenn = 2
*..................Dialog anlegen
  Dialog = NewObject /DLG_WINDOW/
  Dialog.SetCaption("Standardlayout")
*...................Felder anlegen  
*...................Feld fr Combobox
  Combo = NewObject /DLG_COMBOBOX/
  Combo.SetLabel("Liste:") 
  Combo.AddText("Auswahl 1"; 1) 
  Combo.AddText("Auswahl 2"; 2) 
  Combo.AddText("Keine Auswahl"; 0) 
  Combo.SetValue(Kenn)
  Dialog.AddField(Combo)
*...................Feld fr Text
  TextFeld = NewObject /DLG_TEXT/
  TextFeld.SetLabel("Text:")
  TextFeld.SetText(!Text)
  Dialog.AddField(TextFeld)
*...................Feld fr Checkbox
  Check = NewObject /DLG_CHECKBOX/
  Check.SetBoxLabel("Kontrollkstchen")
  Check.SetFieldLabel(" ")
  Check.SetValue(Bool)
  Dialog.AddField(Check)
*...................Feld fr Wert
  Number = NewObject /DLG_NUMBER/ 
  Number.SetLabel("Wert:")
  Number.SetSize(10;3)
  Number.SetValue(Wert)
  Dialog.AddField(Number )
  
*....................Dialog ausfhren
  Ret = Dialog.DoDialog(1)
*....................Ergebnis
  WENN Ret DANN
    Wenn Dialog.IsChanged() Dann Melde "Werte gendert!"
    !Text = TextFeld.GetText()
    Wert = Number.GetValue()
    Bool = Check.GetValue()
    Kenn = Combo.GetValue()
*....................Protokollausgabe
    Melde "Combo    #";Kenn
    Melde "Text     #";!Text
    Melde "Check    #";Bool
    Melde "Wert #.###";Wert
  WEITER

ENDE FUNKTION
* ----------------------------------------------------------------------------- 
* Funktion legt Dialog mit zwei Rahmen an. 
* Der Wert "Pos" steuert, ob  die Rahmen nebeneinander (1) oder untereinander (0) positioniert werden. 
* Der Wert "Rahmen" steuert, ob die Rahmen gezeichnet werden (1) oder nicht (0). 
FUNKTION LayoutZweiRahmen: Pos; Rahmen = 0
  
  * Deklarationen
  SYMBOLE /DLG_WINDOW/ Dialog
  SYMBOLE /DLG_FRAME/ Frame1; Frame2
  SYMBOLE /DLG_TEXT/ TextFeld1; TextFeld2
  SYMBOLE /DLG_NUMBER/ Number1; Number2; Number3
  SYMBOLE * Ret;!Text1; Wert1; Wert3
  SYMBOLE * !Text2; Wert2; !Caption
*...................Inhalte vorbelegen
  !Text1 = "Hallo!"
  !Text2 = "Text"
  Wert1 = 123.456
  Wert2 = 456.123
  Wert3 = 333.333
*..................Dialog anlegen
  !Caption = "Rahmen untereinander"
  WENN Pos == 1 DANN !Caption = "Rahmen nebeneinander"
  Dialog = NewObject /DLG_WINDOW/
  Dialog.SetCaption(!Caption)
*..................zwei Rahmen anlegen
  WENN Rahmen DANN                     | Rahmen zeichnen und beschriften
    Frame1 = Dialog.CreateFrame(1; "Rahmen 1")
    Frame2 = Dialog.CreateFrame(Pos; "Rahmen 2")
  SONST                                | Rahmen nicht zeichnen
    Frame1 = Dialog.CreateFrame()
    Frame2 = Dialog.CreateFrame(Pos)
  WEITER
  Dialog.AdjustFrameSize()             | Hhenanpassung nebeneinanderliegender Rahmen 

*...................Felder fr ersten Rahmen 
  TextFeld1 = NewObject /DLG_TEXT/
  TextFeld1.SetLabel("Text:")
  TextFeld1.SetText(!Text1)
  Frame1.AddField(TextFeld1)
*
  Number1 = NewObject /DLG_NUMBER/ 
  Number1.SetLabel("Wert 1:")
  Number1.SetSize(10;3)
  Number1.SetValue(Wert1)
  Frame1.AddField(Number1)
*...................Felder fr zweiten Rahmen 
  TextFeld2 = NewObject /DLG_TEXT/
  TextFeld2.SetLabel("Text:")
  TextFeld2.SetSize(50)
  TextFeld2.SetText(!Text2)
  Frame2.AddField(TextFeld2)
*
  Number2 = NewObject /DLG_NUMBER/ 
  Number2.SetLabel("Wert 2:")
  Number2.SetSize(10;3)
  Number2.SetValue(Wert2)
  Frame2.AddField(Number2)
*
  Number3 = NewObject /DLG_NUMBER/ 
  Number3.SetLabel("Wert 3:")
  Number3.SetSize(10;3)
  Number3.SetValue(Wert3)
  Frame2.AddField(Number3)
*....................Dialog ausfhren
  Ret = Dialog.DoDialog(1)
*....................Ergebnis
  WENN Ret DANN
    WENN Dialog.IsChanged() DANN Melde "Werte gendert!"
  WEITER
ENDE FUNKTION

* ----------------------------------------------------------------------------- 
FUNKTION LayoutDreiRahmen:

  SYMBOLE /DLG_WINDOW/ Dialog
  SYMBOLE /DLG_FRAME/ Frame1; Frame2; Frame3
  SYMBOLE /DLG_TEXT/ TextFeld1; TextFeld2; TextFeld3
  SYMBOLE /DLG_NUMBER/ Number1; Number2; Number3
  SYMBOLE * Ret;!Text1; Wert1; Wert3; !Text3
  SYMBOLE * !Text2; Wert2; !Caption
*...................Inhalte vorbelegen
  !Text1 = "Hallo!"
  !Text2 = "Text"
  !Text3 = "laaaaaanger Text"
  Wert1 = 123.456
  Wert2 = 456.123
  Wert3 = 333.333
*..................Dialog anlegen
  !Caption = "Rahmen neben-/untereinander"
  Dialog = NewObject /DLG_WINDOW/
  Dialog.SetCaption(!Caption)
*..................drei Rahmen anlegen
  Frame1 = Dialog.CreateFrame(1; "Rahmen 1")
  Frame2 = Dialog.CreateFrame(1; "Rahmen 2") | neben Rahmen 1
  Frame3 = Dialog.CreateFrame(0; "Rahmen 3") | unter Rahmen 1 und 2
  Frame3.SetSize(78;0)                       | Breite fr Rahmen 3 angeben
  Dialog.AdjustFrameSize()         
  
*...................Felder fr ersten Rahmen 
  TextFeld1 = NewObject /DLG_TEXT/
  TextFeld1.SetLabel("Text:")
  TextFeld1.SetText(!Text1)
  Frame1.AddField(TextFeld1)
*
  Number1 = NewObject /DLG_NUMBER/ 
  Number1.SetLabel("Wert 1:")
  Number1.SetSize(10;3)
  Number1.SetValue(Wert1)
  Frame1.AddField(Number1)
*...................Felder fr zweiten Rahmen 
  TextFeld2 = NewObject /DLG_TEXT/
  TextFeld2.SetLabel("Text:")
  TextFeld2.SetText(!Text2)
  Frame2.AddField(TextFeld2)
*  
  Number2 = NewObject /DLG_NUMBER/ 
  Number2.SetLabel("Wert 2:")
  Number2.SetSize(10;3)
  Number2.SetValue(Wert2)
  Frame2.AddField(Number2)
*
  Number3 = NewObject /DLG_NUMBER/ 
  Number3.SetLabel("Wert 3:")
  Number3.SetSize(10;3)
  Number3.SetValue(Wert3)
  Frame2.AddField(Number3)
*...................Feld fr dritten Rahmen 
  TextFeld3 = NewObject /DLG_TEXT/
  TextFeld3.SetLabel("Text:")
  TextFeld3.SetSize(30)
  TextFeld3.SetText(!Text3)
  Frame3.AddField(TextFeld3)
*....................Dialog ausfhren
  Ret = Dialog.DoDialog(1)
*....................Ergebnis
  WENN Ret DANN
    WENN Dialog.IsChanged() DANN Melde "Werte gendert!"
  WEITER
ENDE FUNKTION

* ----------------------------------------------------------------------------- 


